#version 410 core

uniform float fGlobalTime; // in seconds
uniform vec2 v2Resolution; // viewport resolution (in pixels)

uniform sampler1D texFFT; // towards 0.0 is bass / lower freq, towards 1.0 is higher / treble freq
uniform sampler1D texFFTSmoothed; // this one has longer falloff and less harsh transients
uniform sampler1D texFFTIntegrated; // this is continually increasing
uniform sampler2D texChecker;
uniform sampler2D texNoise;
uniform sampler2D texParty;
uniform sampler2D texTex1;
uniform sampler2D texTex2;
uniform sampler2D texTex3;
uniform sampler2D texTex4;
uniform sampler2D texUm;

layout(location = 0) out vec4 out_color; // out_color must be written in order to see anything

vec4 plas( vec2 v, float time )
{
  float c = 0.5 + sin( v.x * 10.0 ) + cos( sin( time + v.y ) * 20.0 );
  return vec4( sin(c * 0.2 + cos(time)), c * 0.15, cos( c * 0.1 + time / .4 ) * .25, 1.0 );
}
vec4 mat(vec3 p){
    return vec4(1);
}
//vec3 normal(vec3 p ){}

float sphere(vec3 p , float l){
    return length(p)-l;
}

float scene(vec3 p){
    float c = 1;
    return sphere(mod(p,c) - (c/2),.1);

}

vec4 trace(vec3 ro, vec3 rd){
    float d = 0;
    vec3 p = ro;

    for (int i = 0; i < 32; i++){
        d = scene(p);
        p += d * rd;
        
        if (d < 0.01){
            return mat(p);
        }
    }
    return vec4(0);
}

void main(void)
{
  vec2 uv = vec2(gl_FragCoord.x / v2Resolution.x, gl_FragCoord.y / v2Resolution.y);
  uv -= 0.5;
  uv /= vec2(v2Resolution.y / v2Resolution.x, 1);
  float FOV = 1;

  vec3 ro = vec3(sin(fGlobalTime),0,fGlobalTime);
  vec3 lookat = vec3(0,0,fGlobalTime + 100);

  vec3 forward = normalize(lookat - ro);
  vec3 right = normalize(vec3(forward.z,0,forward.y));
  vec3 up = normalize(cross(right,forward));
  //vec3 rd = normalize(forward* uv.x + FOV + right *uv.y *FOV *up);
 // vec3 rd = normalize(right + FOV * uv.x + forward * FOV *uv.y *up);
   
  vec3 rd = normalize(right+FOV *uv.x *forward+FOV * uv.y *up);
  vec2 m;
  m.x = atan(uv.x / uv.y) / 3.14;
  m.y = 1 / length(uv) * .2;
  float d = m.y;

  float f = texture( texFFT, d ).r * 100;
  m.x += sin( fGlobalTime ) * 0.1;
  m.y += fGlobalTime * 0.25;

  vec4 t = plas( m * 3.14, fGlobalTime ) / d;
  t = clamp( t, 0.0, 1.0 );
  out_color = (f + t) * trace(ro,rd);
}